/*
  Charlieplexing.h - Library for controlling the charliplexed led board
  from JimmiePRodgers.com
  Created by Alex Wenger, December 30, 2009.
  Modified by Matt Mets, May 28, 2010.
  Released into the public domain.
*/

#ifndef Charlieplexing_h
#define Charlieplexing_h

#include <inttypes.h>

#define SINGLE_BUFFER 0
#define DOUBLE_BUFFER 1
#define SW_LEVEL 0
#define SW_EDGE 1


namespace iLedSign
{
    extern void Init(uint8_t mode = SINGLE_BUFFER);
    extern void ShiftLeft();
    extern void ShiftRight();
    extern void Set(uint8_t x, uint8_t y, uint8_t c);
    extern uint8_t Get(uint8_t x, uint8_t y);
    extern volatile unsigned int tcnt2;
    extern void Flip(bool blocking = false);
    extern void Clear(int set=0);
    extern void Horizontal(int y, int set=0);
    extern void Vertical(int x, int set=0);
    extern uint8_t GetSW(uint8_t edge);
    extern uint8_t GetPeriod(void);
	extern void Vwrite(int x, uint8_t data);
    extern void write(uint8_t y, const uint16_t values[], uint8_t size);
    extern void write90(uint8_t y, const uint16_t values[], uint8_t size);
};

#endif
